const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const friendships = sequelize.define(
    'friendships',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"requested",


"accepted",


"blocked",


"declined"

        ],

      },

requested_at: {
        type: DataTypes.DATE,
      
      

      },

responded_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  friendships.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity







































//end loop



    db.friendships.belongsTo(db.users, {
      as: 'requester',
      foreignKey: {
        name: 'requesterId',
      },
      constraints: false,
    });

    db.friendships.belongsTo(db.users, {
      as: 'addressee',
      foreignKey: {
        name: 'addresseeId',
      },
      constraints: false,
    });




    db.friendships.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.friendships.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return friendships;
};


